package com.nisum.webfluxmongodb.repository;

import com.nisum.webfluxmongodb.dto.ProductDto;
import com.nisum.webfluxmongodb.entity.Product;
import org.springframework.data.domain.Range;
import org.springframework.data.mongodb.repository.ReactiveMongoRepository;
import org.springframework.stereotype.Repository;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Repository
public interface ProductRepository extends ReactiveMongoRepository<Product,String>
{

    Flux<ProductDto> findByPriceBetween(Range<Double> priceRange);


    Mono<ProductDto> findByName(String name);

    Mono<ProductDto> findByPrice(double price);

    Mono<ProductDto> findByQuantity(int qty);
}
